<?php
namespace Incoviba\Service\Venta;

use DateTimeImmutable;
use Incoviba\Repository;
use Incoviba\Model;
use Incoviba\Service;

class Subsidio
{
    public function __construct(
        protected Repository\Venta\Subsidio $subsidioRepository,
        protected Repository\Venta\Pago $pagoRepository,
        protected Repository\Venta\TipoPago $tipoPagoRepository,
        protected Repository\Venta\EstadoPago $estadoPagoRepository,
        protected Repository\Venta\TipoEstadoPago $tipoEstadoPagoRepository,
        protected Service\Money $moneyService
    ) {}

    public function add(array $data): Model\Venta\Subsidio
    {
        $fecha = new DateTimeImmutable($data['fecha']);
        $uf = $data['uf'] ?? $this->moneyService->getUF($fecha);
        $tipoPago = $this->tipoPagoRepository->fetchByDescripcion('vale vista');
        $ahorro = $this->addPago(['fecha' => $fecha->format('Y-m-d'), 'valor' => $data['ahorro'] * $uf, 'uf' => $uf, 'tipo' => $tipoPago->id]);
        $subsidio = $this->addPago(['fecha' => $fecha->format('Y-m-d'), 'valor' => $data['subsidio'] * $uf, 'uf' => $uf, 'tipo' => $tipoPago->id]);
        $subsidio = $this->subsidioRepository->create(['pago' => $ahorro->id, 'subsidio' => $subsidio->id]);
        return $this->subsidioRepository->save($subsidio);
    }
    protected function addPago(array $data): Model\Venta\Pago
    {
        $pago = $this->pagoRepository->create($data);
        $pago = $this->pagoRepository->save($pago);
        $tipoEstado = $this->tipoEstadoPagoRepository->fetchByDescripcion('no pagado');
        $data = [
            'pago' => $pago->id,
            'fecha' => $pago->fecha->format('Y-m-d'),
            'estado' => $tipoEstado->id
        ];
        $estado = $this->estadoPagoRepository->create($data);
        $this->estadoPagoRepository->save($estado);
        return $pago;
    }
}
